package eu.ztsh.wymiana.util;

import eu.ztsh.wymiana.EntityCreator;
import eu.ztsh.wymiana.model.Currency;
import eu.ztsh.wymiana.model.User;
import org.junit.jupiter.api.Test;

import java.util.Map;

import static org.assertj.core.api.Assertions.assertThat;

class UserMapperTest {

    @Test
    void entityToPojoTest() {
        var entity = EntityCreator.userEntity().build();
        var expected = EntityCreator.user();
        assertThat(UserMapper.entityToPojo(entity))
            .usingRecursiveComparison()
            .isEqualTo(expected);
    }

    @Test
    void pojoToEntityTest() {
        var entity = EntityCreator.user();
        var expected = EntityCreator.userEntity().build();
        assertThat(UserMapper.pojoToEntity(entity))
            .usingRecursiveComparison()
            .isEqualTo(expected);
    }

    @Test
    void requestToEntityTest() {
        var request = EntityCreator.userRequest().build();
        var expected = EntityCreator.userEntity().build();
        assertThat(UserMapper.requestToEntity(request))
            .usingRecursiveComparison()
            .isEqualTo(expected);
    }

}
