package eu.ztsh.wymiana.validation;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

class AdultValidatorTest extends ValidatorTest<AdultValidator, String> {

    protected AdultValidatorTest() {
        super(new AdultValidator());
    }

    @Test
    @DisplayName("No digits in PESEL")
    void invalidPatternTest() {
        assertThatValidation("notAPesel").isFalse();
    }

    @Test
    @DisplayName("Not an adult")
    void notAnAdultTest() {
        assertThatValidation("24242400000").isFalse();
    }

    @Test
    @DisplayName("Adult")
    void adultTest() {
        assertThatValidation("88010100000").isTrue();
    }

    @Test
    @DisplayName("Elderly person")
    void seniorTest() {
        assertThatValidation("00010100000").isTrue();
    }

    @Test
    @DisplayName("Invalid date")
    void notAValidDateTest() {
        assertThatValidation("00919100000").isFalse();
    }

}
